/*
 * config.h
 */
#ifndef _CONFIG_H_
#define _CONFIG_H_

typedef struct _configContext {
  char * fname;
  int    linenr;
  char * name;
  char * value;
} ConfigContext;

extern int  parseConfigurationLine (char * fname,
				    int    lineNumber,
				    char * oneLine);

extern int  parseConfigurationFile (char * fname);
extern void showConfigfileContext (ConfigContext * cfg, char * msg);
extern void configIntUnparsable (ConfigContext * cfg);
extern void configIntOutOfRange (ConfigContext * cfg, int min, int max);
extern void configDoubleUnparsable (ConfigContext * cfg);

extern void setConfigRangeInt (int * vp, ConfigContext * cfg);
extern void setConfigInt (int * vp, ConfigContext * cfg);
extern void setConfigDouble (double * vp, ConfigContext * cfg);
extern char * getConfigValue (ConfigContext * cfg);
extern int  getConfigParameter_d (char * par,
				  ConfigContext * cfg,
				  double * dp);
extern int  getConfigParameter_i (char * par,
				  ConfigContext * cfg,
				  int * dp);
extern int  getConfigParameter_f (char * par,
				  ConfigContext * cfg,
				  float * dp);

extern int getConfigParameter_ir (char * par,
				  ConfigContext * cfg,
				  int * ip,
				  int lowInc,
				  int highInc);

extern int getConfigParameter_dr (char * par,
				  ConfigContext * cfg,
				  double * dp,
				  double lowInc,
				  double highInc);

extern int getConfigParameter_fr (char * par,
				  ConfigContext * cfg,
				  float * fp,
				  float lowInc,
				  float highInc);
#endif /* _CONFIG_H_ */
