#ifndef MIDI_H
#define MIDI_H

#include "config.h"

#define MIDI_UTIL_SWELL 0
#define MIDI_UTIL_GREAT 1
#define MIDI_UTIL_PEDAL 2

extern void setMIDIControllerFunction (unsigned char controller,
				       void (*f)(unsigned char uc));

extern void setuMIDIControllerFunction (int utility,
					unsigned char controller,
					void (*f) (unsigned char));

extern void useMIDIControlFunction (char * cfname, void (* f) (unsigned char));

extern void setKeyboardSplitMulti (int flags,
				   int p_splitA_PL,
				   int p_splitA_UL,
				   int p_nshA_PL,
				   int p_nshA_UL,
				   int p_nshA_U);

extern void setKeyboardTransposeA (int t);
extern void setKeyboardTransposeB (int t);
extern void setKeyboardTransposeC (int t);
extern void setKeyboardTranspose (int t);

extern void midiPrimeControllerMapping ();

extern int midiConfig (ConfigContext * cfg);

extern int prepareMIDI ();

extern void setMIDIChannelSwell (int ch);

extern void setMIDINoteShift (char offset);

extern int closeMIDI ();

extern void * MIDIInReader (void * arg);

#endif /* MIDI_H */
